<?php

/*********************************************************************

 freo | 管理画面 | メディア管理 (2010/09/01)

 Copyright(C) 2009-2010 freo.jp

*********************************************************************/

/* メイン処理 */
function freo_main()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//パラメータ検証
	if (!isset($_GET['directory']) or !preg_match('/^[\w\-\/]+$/', $_GET['directory'])) {
		$_GET['directory'] = null;
	}

	//メディアディレクトリ取得
	if ($dir = scandir(FREO_FILE_DIR . 'medias/')) {
		$directories = array('');
		foreach ($dir as $data) {
			if ($data == '.' or $data == '..') {
				continue;
			}
			if (!is_dir(FREO_FILE_DIR . 'medias/' . $data)) {
				continue;
			}

			$directories[] = $data;
		}
	} else {
		freo_error('メディア格納ディレクトリ ' . FREO_FILE_DIR . 'medias/ を開けません。');
	}

	//メディア取得
	$medias = array();
	foreach ($directories as $directory) {
		$target = $directory ? $directory . '/' : '';

		if ($dir = scandir(FREO_FILE_DIR . 'medias/' . $target)) {
			foreach ($dir as $data) {
				if ($data == '.' or $data == '..') {
					continue;
				}
				if (!is_file(FREO_FILE_DIR . 'medias/' . $target . $data)) {
					continue;
				}

				list($width, $height, $size) = freo_file(FREO_FILE_DIR . 'medias/' . $target . $data);

				if (is_file(FREO_FILE_DIR . 'media_thumbnails/' . $target . $data)) {
					list($thumbnail_width, $thumbnail_height, $thumbnail_size) = freo_file(FREO_FILE_DIR . 'media_thumbnails/' . $target . $data);

					$thumbnail_file     = $data;
					$thumbnail_datetime = date('Y-m-d H:i:s', filemtime(FREO_FILE_DIR . 'media_thumbnails/' . $target . $data));
				} else {
					$thumbnail_file     = null;
					$thumbnail_width    = null;
					$thumbnail_height   = null;
					$thumbnail_size     = null;
					$thumbnail_datetime = null;
				}

				$medias[$directory][] = array(
					'file'               => $data,
					'width'              => $width,
					'height'             => $height,
					'size'               => $size,
					'datetime'           => date('Y-m-d H:i:s', filemtime(FREO_FILE_DIR . 'medias/' . $target . $data)),
					'thumbnail_file'     => $thumbnail_file,
					'thumbnail_width'    => $thumbnail_width,
					'thumbnail_height'   => $thumbnail_height,
					'thumbnail_size'     => $thumbnail_size,
					'thumbnail_datetime' => $thumbnail_datetime
				);
			}
		} else {
			freo_error('メディア格納ディレクトリ ' . $directory . ' を開けません。');
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'  => freo_token('create', (isset($_GET['type']) ? $_GET['type'] : null)),
		'medias' => $medias
	));

	if (isset($_GET['type']) and $_GET['type'] == 'iframe') {
		//データ出力
		freo_output('internals/admin/iframe_media.html');
	}

	return;
}

?>
